Name:		hp-ixgbevf
Version:	4.13.3
Release:	1.%{distro}
Group:		System/Kernel
Vendor:		Intel Corporation
URL:		http://www.intel.com/network/connectivity/products/server_adapters.htm
Packager:	Hewlett-Packard Enterprise Company
License:	GPL
Source0:	%{name}-%{version}.tar.gz
Source1:        %{name}.files
BuildRoot:	%{_tmppath}/%{name}-%{version}-build
Summary:	Intel(R) 10GbE PCI Express Ethernet Kernel Module for HPE ProLiant systems ixgbevf Driver for Linux

%define debug_package %{nil}

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default kdump smp xen
%else
%define flav default bigsmp kdump kdumpae smp xen xenpae pae
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%if %{!?KVER:1}%{?KVER:0}
%define flav ""
%endif
%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"el5" '{print $2}')
%if "%{flav}" == ""
%define flav default
%endif
%endif
%endif

%if "%{_vendor}" == "suse"
%if 0%{?suse_version} >= 1315
BuildRequires: kernel-syms
%else
BuildRequires: kernel-source kernel-syms
%endif
%define install_mod_dir updates/%{name}
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -f %{SOURCE1} -x %flav -b}
%else
BuildRequires: %kernel_module_package_buildreqs
%define install_mod_dir extra/%{name}
%{kernel_module_package -f %{SOURCE1} %flav}
%endif

%description
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package KMP
Summary: Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
Group: System/Kernel

%description KMP
Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux
SRPMS available at http://downloads.linux.hpe.com/SDR/repo/spp/<spp version>/hp/source
Public key available at https://h20392.www2.hpe.com/portal/swdepot/displayProductInfo.do?productNumber=HPLinuxCodeSigning

%package doc
Summary: Documentation for the %{name} kernel module
Group: System/Kernel
%if "%{_vendor}" == "redhat"
Requires: %{name}-kmod = %{version}-%{release}
%else
Requires: %{name}-kmp
%endif

%description doc
Documentation for the Intel(R) 10GbE PCI Express Ethernet Kernel Module for HP ProLiant systems ixgbevf Driver for Linux

%prep
%setup
set -- *
mkdir source
mv "$@" source/
mkdir obj
echo "override ixgbevf * weak-updates/%{name}" > %{name}.conf
echo "add_drivers+=\" ixgbevf \"" > %{name}-oob.conf

%build
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	rm -rf obj/$flavor
	cp -r source obj/$flavor
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor}

	#mark modules executable so that strip-to-file can strip them
	find obj/$flavor/ -name "*.ko" -type f -exec chmod u+x '{}' +
done
gzip < source/ixgbevf.7 > source/ixgbevf.7.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=%install_mod_dir
export EXTRA_CFLAGS='-DVERSION="%version"'

%if %{!?KVER:0}%{?KVER:1}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

for flavor in %{flavors}; do
	make -C $PWD/obj/$flavor/src KSRC=%{kernel_source $flavor} install

	#Cleanup unnecessary kernel-generated module dependency files.
	find $INSTALL_MOD_PATH/lib/modules -iname 'modules.*' -exec rm {} \;
done
install -D -m 644 source/ixgbevf.7.gz $RPM_BUILD_ROOT/%{_mandir}/man7/ixgbevf.7.gz
install -d %{buildroot}%{_sysconfdir}/depmod.d/
install %{name}.conf %{buildroot}%{_sysconfdir}/depmod.d/

install -d %{buildroot}%{_sysconfdir}/dracut.conf.d/
install %{name}-oob.conf %{buildroot}%{_sysconfdir}/dracut.conf.d/

%define _unpackaged_files_terminate_build 0

%postun doc
if [ -f %{_mandir}/man7/ixgbevf.7.gz ]; then
	exit 0
fi

%clean
rm -rf %{buildroot}

%files
%{_sysconfdir}/depmod.d/%{name}.conf
%{_sysconfdir}/dracut.conf.d/%{name}-oob.conf

%files doc
%defattr(-, root, root)
%{_mandir}/man7/ixgbevf.7.gz
%doc source/COPYING source/README

%changelog
* Fri Sep 4 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.9.2-1
- This driver add support for new mailbox communication between PF and VF

* Mon Aug 10 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.8.1-1
- Add SLES15 SP2 support

* Fri May 15 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.7.1-1
- Remove irqs only when they are set up
- Fix guest OS crashes during VFs resets

* Mon Apr 6 2020 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.7.0-1
- This driver use macro to handle change in nd_tx_timeout.

* Wed Sep 24 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.6.4-1
- This driver fixes an issue of Infinite recursion in device shutdown path due to a corner case when PCIe link was down
- Fix the issue of typo in ethtool stats
- Added RHEL7u7 Support.
- Added RHEL8 Support.
- Added SLES15SP1 Support.

* Wed Apr 10 2019 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.5.3-1
- This driver fixes the issue when configuring MTU on VF in Guest OS would be failed.

* Mon Dec 10 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.5.1
- Added RHEL7u6 Support.
- Added SLES12SP4 Support.

* Wed Aug 08 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.3.5-0[rhel6.10, rhel7u5], 4.3.3.1-8[For other OSs]
- Added RHEL6.10 Support.
- Added RHEL7.5 Support.

* Thu Jul 26 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.3.3.1-8
- This driver fixes the Spectre/Meltdown issue.
- Added SLES15 Support.

* Wed May 16 2018 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.3.3.1-5
- This driver fixes the issue of failed to install driver on SLES12SP2

* Mon Nov 06 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.3.2-1
- This driver fixes the issue of unable to set MTU value more than 1500 in SUSE12SP3 with Intel NICs

* Fri Jul 28 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.2.1-4.rhel7u4
- Added support for HPE Ethernet 10Gb 2-port 562FLR-T Adapter
- Added support for HPE Ethernet 10Gb 2-port 562T Adapter
- Added SLES12SP3 support
- Added RHEL 7.4 support
- Fix the issue of sriov_totalvfs reporting incorrect number of supported VFs

* Tue Mar 21 2017 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 4.0.5-2[rhel6u9], 4.0.5-1[For other OSs]
- Added SLES12SP2 support
- Added RHEL 7.3 support
- Fixed the issue of installing ixgbevf corrupts ability of virtual machine to boot from SLES 11 SP4

 Tue Jun 21 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.2.2-1
- Added RHEL 6.8 support
- Fix the issue of setting of invalid MTU
- Added support for ethtool RSS get/set functionality
- Fix the issue of No error generated if untrusted VM user tries to set user defined VF MAC address

* Wed Apr 13 2016 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> 3.1.2-2
 - Fix the issue of packet loss in Virtual Functions(VF) in cases where Physical Function(PF) interface is brought up after VF.
 - Added support for Multicast promiscous mode for trusted Virtual Functions
